=== debian/changelog ===
victoriametrics (1.79.14+ds1-2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:23:51 +1100

victoriametrics (1.79.14+ds1-2) unstable; urgency=medium

  * Team upload
  * Backport upstream fix for Go1.22

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 29 Feb 2024 23:26:54 +0800

victoriametrics (1.79.14+ds1-1) unstable; urgency=medium

  * New upstream LTS release.
    - Fix unaligned read access causing SIGBUS on some architectures.
      (Closes: #1051392)
  * Bump versions for victoria-metrics module build-dependencies.

 -- Guillem Jover <gjover@sipwise.com>  Fri, 08 Sep 2023 23:59:45 +0200

victoriametrics (1.79.5+ds1-3) unstable; urgency=medium

  * Take patch from upstream to fix flaky test due to math rand.
  * Switch to Standards-Version 4.6.2 (no changes needed)
  * Update copyright years

 -- Guillem Jover <gjover@sipwise.com>  Thu, 10 Aug 2023 18:34:38 +0200
